Kea: isc::dhcp::DUIDConfigParser Class Reference

| Kea 3.2.0-git

isc::dhcp::DUIDConfigParser Class Reference

Parser for server DUID configuration. More...

`#include <duid_config_parser.h>`

Inheritance diagram for isc::dhcp::DUIDConfigParser:
[legend]

## Public Member Functions
void | parse (const CfgDUIDPtr &cfg, isc::data::ConstElementPtr duid_configuration)
| Parses DUID configuration.
Public Member Functions inherited from isc::data::SimpleParser
uint16_t | getUint16 (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a value converted to uint16_t.
uint32_t | getUint32 (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a value converted to uint32_t.
uint8_t | getUint8 (ConstElementPtr scope, const std::string &name)
| Get an uint8_t value.
const isc::util::Triplet< uint32_t > | parseIntTriplet (const data::ConstElementPtr &scope, const std::string &name)
| Parses an integer triplet.

## Additional Inherited Members
Static Public Member Functions inherited from isc::data::SimpleParser
static void | checkKeywords (const SimpleKeywords &keywords, isc::data::ConstElementPtr scope)
| Checks acceptable keywords with their expected type.
static void | checkRequired (const SimpleRequiredKeywords &required, isc::data::ConstElementPtr scope)
| Checks that all required keywords are present.
static size_t | deriveParams (isc::data::ConstElementPtr parent, isc::data::ElementPtr child, const ParamsList &params)
| Derives (inherits) parameters from parent scope to a child.
static isc::asiolink::IOAddress | getAddress (const ConstElementPtr &scope, const std::string &name)
| Returns a IOAddress parameter from a scope.
static bool | getBoolean (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a boolean parameter from a scope.
static double | getDouble (const ConstElementPtr &scope, const std::string &name)
| Returns a floating point parameter from a scope.
static int64_t | getInteger (isc::data::ConstElementPtr scope, const std::string &name)
| Returns an integer parameter from a scope.
static int64_t | getInteger (isc::data::ConstElementPtr scope, const std::string &name, int64_t min, int64_t max)
| Returns an integer parameter from a scope and checks its range.
static const data::Element::Position & | getPosition (const std::string &name, const data::ConstElementPtr parent)
| Utility method that returns position of an element.
static std::string | getString (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a string parameter from a scope.
template<typename T>
static void | rangeCheckedInteger (isc::data::ConstElementPtr scope, const std::string &name, T &output_value)
| Fetches a range-checked integer parameter from a scope.
static size_t | setDefaults (isc::data::ElementPtr scope, const SimpleDefaults &default_values)
| Sets the default values.
static size_t | setListDefaults (isc::data::ConstElementPtr list, const SimpleDefaults &default_values)
| Sets the default values for all entries in a list.
Protected Member Functions inherited from isc::data::SimpleParser
template<typename target_type, target_type convert>
target_type | getAndConvert (isc::data::ConstElementPtr scope, const std::string &name, const std::string &type_name)
| Returns a converted value from a scope.
template<typename int_type>
int_type | getIntType (isc::data::ConstElementPtr scope, const std::string &name)
| Returns an integer value with range checking from a scope.

## Detailed Description

Parser for server DUID configuration.

This parser currently supports the following DUID types:

- DUID-LLT,
- DUID-EN

- DUID-LL

  Todo
    Add support for DUID-UUID in the parser.

Definition at line 26 of file duid_config_parser.h.

## Member Function Documentation

## ◆ parse()

void isc::dhcp::DUIDConfigParser::parse | ( | const CfgDUIDPtr & | cfg,
|  | isc::data::ConstElementPtr | duid_configuration )

Parses DUID configuration.

Parameters

  cfg | parsed DUID configuration will be stored here
  duid_configuration | Data element holding a map representing DUID configuration.

Exceptions

  DhcpConfigError | If the configuration is invalid.

Definition at line 26 of file duid_config_parser.cc.

References isc::dhcp::DHCPSRV_CFGMGR_CONFIGURE_SERVERID, isc::dhcp::dhcpsrv_logger, isc::dhcp::DUID::DUID_EN, isc::dhcp::DUID::DUID_LL, isc::dhcp::DUID::DUID_LLT, isc::dhcp::DUID::DUID_UNKNOWN, isc::data::SimpleParser::getBoolean(), isc::data::SimpleParser::getPosition(), isc::data::SimpleParser::getString(), isc::data::SimpleParser::getUint16(), isc::data::SimpleParser::getUint32(), isc_throw, and LOG_WARN.

Referenced by isc::dhcp::processDhcp6Config().

Here is the call graph for this function:

The documentation for this class was generated from the following files:

- duid_config_parser.h
- duid_config_parser.cc